
#include <stdio.h>
#include <stdlib.h>

#define      MAX      10

typedef struct Node
{
	int Data;
	struct Node* pNext;
}Node;

/*Ʈ ͸ ϸ鼭 ϴ Լ*/
void AddDataOne(int Num);

/*Ʈ ͸ ϸ鼭 ϴ Լ*/
void AddDataTwo(int Num);

/*Ʈ ͸ ϴ Լ*/
void Display(void);

/*ḮƮ   ϴ Լ*/
void DeleteAllNode(void);

Node* pHead = NULL;

int main(void)
{
	int Number[MAX] = { 5 ,8 ,9, 1, 3, 2, 6, 4, 7, 10 };

	for (int i = 0; i < MAX ; i++)
		AddDataTwo(Number[i]);

	Display();

	DeleteAllNode();

	return 0;
}

/*Ʈ ͸ ϸ鼭 ϴ Լ*/
void AddDataOne(int Num)
{
	//	͸ Ʈ  ÿ,  ϸ鼭  .
	Node* NewNode = (Node*)malloc(sizeof(Node));
	NewNode->Data = Num;
	NewNode->pNext = NULL;

	if( pHead == NULL )
	{
		pHead = NewNode;
		return;
	}
	
	else if( pHead != NULL )
	{
		if( pHead->Data > NewNode->Data )
		{
			NewNode->pNext = pHead;
			pHead = NewNode;
			return;
		}
	}
	
	Node* pCur = pHead;
	Node* pSearch = NULL;

	//	  ġ ã´.
	while( pCur != NULL )
	{
		if( pCur->Data < NewNode->Data )
		{
			pSearch = pCur;
			pCur = pCur->pNext;
		}

		else if( pCur->Data > NewNode->Data )
		{
			NewNode->pNext = pCur;
			break;
		}
	}

	if( pSearch != NULL )	
		pSearch->pNext = NewNode;
}

/*Ʈ ͸ ϸ鼭 ϴ Լ*/
void AddDataTwo(int Num)
{
	Node* NewNode = (Node*)malloc(sizeof(Node));
	NewNode->Data = Num;
	NewNode->pNext = NULL;

	if (pHead == NULL)
		pHead = NewNode;
	else 
	{
		Node* pCur = pHead;
		Node* pPrev = pHead;
		int IsSelected = 0;

		while (pCur->pNext != NULL) 
		{
			if (Num < pCur->Data) 
			{
				NewNode->pNext = pCur;

				if (pCur == pHead)
					pHead = NewNode;

				else
					pPrev->pNext = NewNode;

				IsSelected = 1;
				break;
			}

			pPrev = pCur;
			pCur = pCur->pNext;
		}

		if (!IsSelected)
			pCur->pNext = NewNode;
	}
}

/*Ʈ ͸ ϴ Լ*/
void Display(void)
{
	if(pHead == NULL)
		return;

	Node* pCur = pHead;

	while(pCur != NULL)
	{
		printf("%2d ", pCur->Data);
		pCur = pCur->pNext;
	}

	printf("\n");
}

/*ḮƮ   ϴ Լ*/
void DeleteAllNode(void)
{
	Node* pDel;
	Node* pCur;

	if (pHead == NULL)
		return;

	pCur = pHead;

	while (pCur != NULL)
	{
		pDel = pCur;
		pCur = pCur->pNext;

		free(pDel);
	}
}
